//+------------------------------------------------------------------+
//|                                      NewASCTrend1RAVI_Expert.mq4 |
//|                             Copyright  2006,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//----  
extern int RAVI_Timeframe = 240;
extern int ASCT_Timeframe = 1440;
//----   ר 
extern int Buy_Sell_Custom = 2; // 0-Buy, 1-Sell, 2-Buy+Sell
//----     BUY  
extern double Money_Management_Up = 0.1;
extern int RISK_Up = 3;
extern int Period1_Up = 7; 
extern int Period2_Up = 65; 
extern int MA_Metod_Up = 0;
extern int PRICE_Up = 0;
extern int STOPLOSS_Up = 50;
extern int TAKEPROFIT_Up = 100;
//----     SELL  
extern double Money_Management_Dn = 0.1;
extern int RISK_Dn = 3;
extern int Period1_Dn = 7; 
extern int Period2_Dn = 65; 
extern int MA_Metod_Dn = 0;
extern int PRICE_Dn = 0;
extern int STOPLOSS_Dn = 50;
extern int TAKEPROFIT_Dn = 100;
//----   
double RAVI_Up[];
double RAVI_Dn[];
double ASCTrend1_Up[];
double ASCTrend1_Dn[];
//+------------------------------------------------------------------+
//| Get_ASCTrend1Series functions()                                  |
//+------------------------------------------------------------------+
#include <Get_ASCTrend1Series.mqh>
//+------------------------------------------------------------------+
//| Get_RAVISeries functions()                                       |
//+------------------------------------------------------------------+
#include <Get_RAVISeries.mqh>
//+------------------------------------------------------------------+
//| Custom Expert functions                                          |
//+------------------------------------------------------------------+
#include <Lite_EXPERT.mqh>
//+------------------------------------------------------------------+
//| Custom Expert initialization function                            |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   if(RAVI_Timeframe != 1)
       if(RAVI_Timeframe != 5)
           if(RAVI_Timeframe != 15)
               if(RAVI_Timeframe != 30)
                   if(RAVI_Timeframe != 60)
                       if(RAVI_Timeframe != 240)
                           if(RAVI_Timeframe != 1440)
                               Print(" RAVI_Timeframe  " + 
                                     "   " + RAVI_Timeframe+"!!!");
//---- 
   if(ASCT_Timeframe != 1)
       if(ASCT_Timeframe != 5)
           if(ASCT_Timeframe != 15)
               if(ASCT_Timeframe != 30)
                   if(ASCT_Timeframe != 60)
                       if(ASCT_Timeframe != 240)
                           if(ASCT_Timeframe != 1440)
                               Print(" ASCT_Timeframe  " + 
                                     "   " + ASCT_Timeframe+"!!!");
//----                      
   if(RAVI_Timeframe > ASCT_Timeframe) 
       Print(" ASCT_Timeframe      RAVI_Timeframe");                   
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom Expert iteration function                                 |
//+------------------------------------------------------------------+
int start()
  {
//----          
   if(iBars(NULL, ASCT_Timeframe) < 3 + RISK_Up*2 + 1 + 1)
       return(0);
   if(iBars(NULL, ASCT_Timeframe) < 3 + RISK_Dn*2 + 1 + 1)
       return(0);
//----
   if(iBars(NULL, RAVI_Timeframe) < MathMax(Period1_Up, Period2_Up + 4))
       return(0);
   if(iBars(NULL, RAVI_Timeframe) < MathMax(Period1_Dn, Period2_Dn + 4))
       return(0);
//----       
   static int LastBars;
//----      
   bool BUY_Sign, SELL_Sign;
//----         
   if(LastBars != iBars(NULL, RAVI_Timeframe))
   switch(Buy_Sell_Custom)
     {
       case 0: 
         {
           Get_RAVISeries(0, Symbol(), RAVI_Timeframe, false, Period1_Up,
                          Period2_Up, MA_Metod_Up, PRICE_Up, RAVI_Up);
           //----
           Get_ASCTrend1Series(0, Symbol(), ASCT_Timeframe, false, 
                               RISK_Up, ASCTrend1_Up);  
           break;
         }
       case 1: 
         {            
           Get_RAVISeries(1, Symbol(), RAVI_Timeframe, false, Period1_Dn,
                          Period2_Dn, MA_Metod_Dn, PRICE_Dn, RAVI_Dn);
           //----
           Get_ASCTrend1Series(1, Symbol(), ASCT_Timeframe, false, 
                               RISK_Dn, ASCTrend1_Dn); 
           break;
         }
       default:
         {
           Get_RAVISeries(0, Symbol(), RAVI_Timeframe, false, Period1_Up,
                          Period2_Up, MA_Metod_Up, PRICE_Up, RAVI_Up);
           //----
           Get_ASCTrend1Series(0, Symbol(), ASCT_Timeframe, false,
                               RISK_Up, ASCTrend1_Up); 
           //----              
           Get_RAVISeries(1, Symbol(), RAVI_Timeframe, false, Period1_Dn, 
                          Period2_Dn, MA_Metod_Dn, PRICE_Dn, RAVI_Dn);
           //----
           Get_ASCTrend1Series(1, Symbol(), ASCT_Timeframe, false,
                               RISK_Dn, ASCTrend1_Dn); 
         }
     }
//----  
   LastBars = iBars(NULL, RAVI_Timeframe);
//----    
   switch(Buy_Sell_Custom)
     {
       case 0: 
         {
           if(RAVI_Up[2] - RAVI_Up[3] < 0)
               if(RAVI_Up[1] - RAVI_Up[2] > 0)
                   if(ASCTrend1_Up[1] > 0)
                       BUY_Sign = true;
           break;
         }
       case 1: 
         {
           if(RAVI_Dn[2] - RAVI_Dn[3] > 0)
               if(RAVI_Dn[1] - RAVI_Dn[2] < 0)
                   if(ASCTrend1_Dn[1] < 0)
                       SELL_Sign = true;
           break;
         }
       default:
         {
           if(RAVI_Up[2] - RAVI_Up[3] < 0)
               if(RAVI_Up[1] - RAVI_Up[2] > 0)
                   if(ASCTrend1_Up[1] > 0)
                       BUY_Sign = true;
           //----+                  
           if(RAVI_Dn[2] - RAVI_Dn[3] > 0)
               if(RAVI_Dn[1] - RAVI_Dn[2] < 0)
                   if(ASCTrend1_Dn[1] < 0)
                       SELL_Sign = true;
         }
     }
//----   
   switch(Buy_Sell_Custom)
     {
       case 0: 
         {
           OpenBuyOrder(BUY_Sign, Money_Management_Up, STOPLOSS_Up, 
                        TAKEPROFIT_Up);
           break;
         }
       case 1: 
         {
           OpenSellOrder(SELL_Sign, Money_Management_Dn, STOPLOSS_Dn, 
                         TAKEPROFIT_Dn);
           break;
         }
       default:
         {
           OpenBuyOrder(BUY_Sign, Money_Management_Up, STOPLOSS_Up, 
                        TAKEPROFIT_Up);
           OpenSellOrder(SELL_Sign, Money_Management_Dn, STOPLOSS_Dn, 
                         TAKEPROFIT_Dn);
         }
     }
   return(0);
  }
//+------------------------------------------------------------------+